SystemOrganization addCategory: #'CS528-UT3Base'!

Object subclass: #UT3Board
	instanceVariableNames: 'boardMatrix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Board commentStamp: '<historical>' prior: 0!
An UT3Board is a board.

Instance Variables
!

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 18:42'!
checkWinningWithCol: aSet

	|  |
	! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 18:42'!
checkWinningWithMatrix: aMatrix

	|  |
	! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 18:42'!
checkWinningWithRow: aSet

	|  |
	! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 18:42'!
checkWinningWithSet: aSet

	|  |
	! !

!UT3Board methodsFor: 'initialize-release' stamp: 'Oliver 7/1/2013 18:30'!
initialize 

	|  |
	boardMatrix := Matrix new: 9.
	boardMatrix atAllPut: 0.! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 18:43'!
player: aPlayer moveX: aMove1 moveY: aMove2

	| tempR tempC subMatrix |
	( (0) == boardMatrix at: aMove1 at: aMove2 )
	ifTrue:[ boardMatrix at: aMove1 at: aMove2 put: aPlayer ]
	ifFalse:[ self error: 'Player could only be 1 or 2 and one can only play in an empty slot!!'   ].
	
	tempR := (aMove1 - (aMove1 % 3)) * 3 + 1.
	tempC := (aMove2 - (aMove2 % 3)) * 3 + 1.
	self checkWinningWithMatrix: (subMatrix := boardMatrix atRows: tempR to: (tempR+2) columns: tempC to: (tempC+2)).
	! !

Object subclass: #UT3System
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3System commentStamp: '<historical>' prior: 0!
An UT3System is the class encapsulating an entire Ultimate TicTacToe game.

It contains an interface to make moves for each player, and holds an instance of UT3Board that represents the game board state, and is stateful in the sense that it records each player's move.

You can use the provided API to get the which player's turn it is, etc. Invalid moves will throw MoveError.

Instance Variables
!
